function checkSiteName(siteName) {
    var regex = /^[A-Za-z0-9_\-\.]+$/;
    return regex.test(siteName);
}

function addSite() {
    var textbox = document.getElementById("siteTextbox");
    var siteName = textbox.value;

    if(siteName.length == 0)
        return false;

    if(! checkSiteName(siteName)) {
        alert("Invalid characters in site name.\n\nValid characters are A-Z, 0-9, _ and ."); 
        return;
    }

    var siteList = document.getElementById("sitelist");
    //if( (siteName.length > 0) && (siteList.getIndexOfItem(siteName) > -1) ) {
    siteList.appendItem(siteName, "");
    textbox.value = "";
}

function removeSite() {
    var siteList = document.getElementById("sitelist");
    var index = siteList.selectedIndex;
    if(index != -1) {
        siteList.removeItemAt(index);
    }
}

function removeAllSites() {
    var siteList = document.getElementById("sitelist");

    if(confirm("Are you sure you want to clear the whitelist?")) {
        while(siteList.getRowCount() > 0)
            siteList.removeItemAt(0);
    }
}

function doOK() {
    var siteList = document.getElementById("sitelist");
    var numRows = siteList.getRowCount();
    var prefStr = "";

    for(i = 0; i < numRows; i++) {
        if(i != 0) prefStr += ",";
        prefStr += siteList.getItemAtIndex(i).label;
    }

    savePref(prefStr);
    window.close();
}

function loadPref() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);

    var pref = prefs.getCharPref("flashblock.whitelist");

    return pref;
}

function savePref(prefStr) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);

    var res = prefs.setCharPref("flashblock.whitelist", prefStr);
}

function onLoad() {
	loadWhitelist();
}

function loadWhitelist() {
    var prefStr = loadPref();
    var array = prefStr.split(",");

    var siteList = document.getElementById("sitelist");
    while(siteList.getRowCount() > 0)
        siteList.removeItemAt(0);

	if(prefStr) {
	    for (i = 0; i < array.length; i++) {
    	    siteList.appendItem(array[i]);
    	}
	}
}

function doCancel() {
    window.close();
}

function siteInput(siteField) {
	document.getElementById("btnAdd").disabled = !siteField.value;
}

function siteSelected(siteList) {
	document.getElementById("btnRemove").disabled = (siteList.selectedIndex == -1);
}
